<template>
  <div class="home">
    <v-container>
      <v-col sm="5" justify="center">
        <v-form ref="form">
          <v-row>
            <v-date-picker
              v-model="date"
              full-width
            ></v-date-picker>
            <v-textarea 
              rounded 
              outlined 
              solo 
              full-width 
              :autoGrow="false" 
              v-model="title"
              required
              :rules="rules"
            />
          </v-row>
          <v-row justify="space-between">
            <v-btn-toggle
              v-model="priority"
              dense
            >
              <v-btn> Normal </v-btn>
              <v-btn class="extra"> Extra </v-btn>
            </v-btn-toggle>
            <v-btn v-on:click="add" text large> Add </v-btn>
          </v-row>
        </v-form>
      </v-col>
      <v-col sm="12" v-for="(todo) in todoList" :key="todo.id">
          <v-col sm="5"  v-on:click="submit(todo)" v-if="todo.status == 'new'">
            <TodoCard :info="todo" mode="view" />
          </v-col>
      </v-col>
    </v-container>
  </div>
</template>

<script>

import TodoCard from '../components/Card'
export default {
  name: 'Home',
  components: {
    TodoCard,
  },
  data() {
    return {
      title: null,
      date:null,
      priority:0,
      rules: [
        v => !!v || 'Field is required',
      ],
    }
  },
  computed:{
        todoList: {
            get: function(){
              return this.$store.getters.todoList.slice().sort((a,b) => {
                let d1 = Date.parse(a.date);
                let d2 = Date.parse(b.date);
                return b.priority - a.priority || d1 - d2;
                });
            }
        }
    },
    methods:{
      submit(todo){
        this.$router.push(`/${todo.id}`)
      },
      add(){
        if(this.$refs.form.validate() && this.date){
          this.$store.dispatch('add', {
            "title": this.title,
            "date": this.date,
            "priority": this.priority,
            "status": "new",
          })
        }else {
          alert('Заполните все поля')
        }
        this.$refs.form.reset()
        window.scrollTo(0,document.body.scrollHeight);
      },
    },
}
</script>

<style lang="scss">
  .extra {
    color: red !important;
  }
</style>
